#include<simplecpp>
#include<iostream>
#include<cstdio>
#include<cstring>

using namespace std;

int board[9][9];
int solvedboard[9][9];
int helpboard[9][9];
FILE*fpin;

struct slots{

    Rectangle r;
    Text *t;
};

int Levelcheck(int v){
int m=v/65536;
int n=v%65536;

for(int k=0;k<4;k++){
    if(k*60+30<= m && m<=k*60+50 && 290<=n && n<=310){return k+1;}
}
return 5;
}

void Copyboard(int board[9][9],FILE*fpin,int helpboard[9][9]){

for(int i=0;i<9;i++){
    for(int j=0;j<9;j++){
    fscanf(fpin,"%d",&board[i][j]);

    }
}

for(int i=0;i<9;i++){
    for(int j=0;j<9;j++){
    if(board[i][j]!=0){helpboard[i][j]=1;}
    else{helpboard[i][j]=0;}
    }
    }
return ;
}

void Copysolvedboard(int solvedboard[9][9],FILE*fpin){


for(int i=0;i<9;i++){
    for(int j=0;j<9;j++){
    fscanf(fpin,"%d",&solvedboard[i][j]);
    }
}
return ;
}
bool CheckingValidity(int board[9][9],int i,int j){
    int p= board[i][j];
    for(int k = 0; k<9; k++){
         if(k!=j){ if(board[i][k] == p) {return false;}
         else{ continue;}
          }
          }

// THIS IS USED FOR CHECKING THE CONFLICTS RELATED WITH THE ROW
// IF IT IS INVALID IT RETURNS FALSE OR IT CONTINUES TO EXECUTE LATER

        for(int q = 0; q<9; q++){
          if(q!=i){if(board[q][j] == p) {return false;}
          else{ continue;}
          }
        }


// THE REST CODE IS USED FOR CHECKING IN THEIR RESPECTIVE 3X3 MATRICES
        if((j == 0 || j == 3 || j == 6) && (i == 0 || i == 3 || i == 6))
          {
             if(board[i][j+1] == p || board[i][j+2] == p || board[i+1][j] == p ||
                 board[i+2][j] == p || board[i+1][j+1] == p || board[i+1][j+2] == p ||
                     board[i+2][j+1] == p || board[i+2][j+2] == p){return false;}
          }



        if((j == 0 || j == 3 || j == 6) && (i == 2 || i == 5 || i == 8))
          {
             if(board[i-1][j] == p || board[i-2][j] == p || board[i][j+1] == p ||
                 board[i][j+2] == p || board[i-1][j+1] == p || board[i-1][j+2] == p ||
                     board[i-2][j+1] == p || board[i-2][j+2] == p){return false;}
          }


        if((j == 0 || j == 3 || j == 6) && (i == 1 || i == 4 || i == 7))
          {
             if(board[i-1][j] == p || board[i+1][j] == p || board[i-1][j+1] == p ||
                 board[i][j+1] == p || board[i+1][j+1] == p || board[i-1][j+2] == p ||
                     board[i][j+2] == p || board[i+1][j+2] == p){return false;}
        }



        if((j == 1 || j == 4 || j == 7) && (i == 0 || i == 3 || i == 6))
          {
             if(board[i+1][j] == p || board[i+2][j] == p || board[i+1][j+1] == p ||
                 board[i][j+1] == p || board[i+2][j+1] == p || board[i+1][j-1] == p ||
                     board[i][j-1] == p || board[i+2][j-1] == p){return false;}
          }


        if((j == 1 || j == 4 || j == 7) && (i == 1 || i == 4 || i == 7))
          {
             if(board[i-1][j] == p || board[i-1][j-1] == p || board[i-1][j+1] == p ||
                 board[i][j+1] == p || board[i][j-1] == p || board[i+1][j+1] == p ||
                     board[i+1][j] == p || board[i+1][j-1] == p){return false;}
                               }



        if((j == 1 || j == 4 || j == 7) && (i == 2 || i == 5 || i == 8))
          {
             if(board[i][j-1] == p || board[i][j+1] == p || board[i-1][j] == p ||
                 board[i-1][j+1] == p || board[i-1][j-1] == p || board[i-2][j] == p ||
                     board[i-2][j+1] == p || board[i-2][j-1] == p) return false;
          }


        if((j == 2 || j == 5 || j == 8) && (i == 0 || i == 3 || i == 6))
          {
             if(board[i][j-1] == p || board[i][j-2] == p || board[i+1][j] == p ||
                 board[i+1][j-1] == p || board[i+1][j-2] == p || board[i+2][j] == p ||
                     board[i+2][j-1] == p || board[i+2][j-2] == p) {return false;}
          }


        if((j == 2 || j == 5 || j == 8) && (i == 1 || i == 4 || i == 7))
          {
             if(board[i-1][j] == p || board[i-1][j-1] == p || board[i-1][j-2] == p ||
                 board[i][j-1] == p || board[i][j-2] == p || board[i+1][j] == p ||
                     board[i+1][j-1] == p || board[i+1][j-2] == p) {return false;}
          }


        if((j == 2 || j == 5 || j == 8) && (i == 2 || i == 5 || i == 8))
          {
             if(board[i][j-1] == p || board[i][j-2] == p || board[i-1][j] == p ||
                 board[i-1][j-1] == p || board[i-1][j-2] == p || board[i-2][j] == p ||
                     board[i-2][j-1] == p || board[i-2][j-2] == p) {return false;}
          }

        return true;
      }


int GetValue(int m,int n){

if(370<= m && m<=390)
    {
        for(int k=0;k<10;k++){if(k*40+10<= n && n<=k*40+30){return k;}}


    }
    else{return 10;}
}

void Copysolution(int board[9][9],int solvedboard[9][9]){
    for(int i=0;i<9;i++){
    for(int j=0;j<9;j++){
    board[i][j]=solvedboard[i][j];
    }
    }
}


main_program{

initCanvas("Game",400,630);

Text Sud(180,200,"Sudoku");
Sud.setColor(GREEN);
Rectangle Newga(90,400,100,24);
Text NewG(90,400,"Newgame");
Rectangle Qui(270,400,100,24);
Text Quit(270,400,"Quit");
Rectangle Hardness[4];
Text Level[4];
Text Hardness1[3];

do{
   int v=getClick();
   int m=v/65536;
   int n=v%65536;
   if(220<= m && m<=320 && 388<=n && n<=412){return -1;}
   if(40<= m && m<=140 && 388<=n && n <=412){
    Sud.hide();
    Newga.hide();
    NewG.hide();
    Qui.hide();
    Quit.hide();
    break;}
   else{continue;}
   }while(true);

Rectangle Eas(180,250,100,24);
Rectangle Med(180,300,100,24);
Rectangle Har(180,350,100,24);
Text SelLe(180,100,"Select LEVEL");
Text Easy(180,250,"Easy");
Text Medi(180,300,"Medium");
Text Hard(180,350,"Hard");

for(;;){
    int v=getClick();
    int m=v/65536;
    int n=v%65536;
    if((130<= m && m<=230 && 238<=n && n<=262)||(130<= m && m<=230 && 288<=n && n<=312)||(130<= m && m<=230 && 338<=n && n<=362)){
        Eas.hide();
        Easy.hide();
        Med.hide();
        Medi.hide();
        Har.hide();
        Hard.hide();
        SelLe.hide();
        for(int k=0;k<4;k++){
        Hardness[k].reset(k*60+40,300,20,20);
        Level[k].reset(k*60+40,300,k+1);}
    }
    if(130<= m && m<=230 && 238<=n && n<=262){
        Hardness1[0].reset(180,150,"Please select one of the following");
        for(;;){
            int v=getClick();
            int z=Levelcheck(v);
        if(0<z&&z<5){
            Hardness1[0].hide();
            for(int k=0;k<4;k++){
        Hardness[k].hide();
        Level[k].hide();
        }
        switch(z){
        case 1:fpin=fopen("Easy1.txt","r");
                if(fpin==NULL){return -1;}
                Copyboard(board,fpin,helpboard);
                fclose(fpin);
                fpin=fopen("Easy1solved.txt","r");
                if(fpin==NULL){return -1;}
                Copysolvedboard(solvedboard,fpin);
                fclose(fpin);
                break;
        case 2:fpin=fopen("Easy2.txt","r");
                if(fpin==NULL){return -1;}
                Copyboard(board,fpin,helpboard);
                fclose(fpin);
                fpin=fopen("Easy2solved.txt","r");
                if(fpin==NULL){return -1;}
                Copysolvedboard(solvedboard,fpin);
                fclose(fpin);
                break;
        case 3:fpin=fopen("Easy3.txt","r");
                if(fpin==NULL){return -1;}
                Copyboard(board,fpin,helpboard);
                fclose(fpin);
                fpin=fopen("Easy3solved.txt","r");
                if(fpin==NULL){return -1;}
                Copysolvedboard(solvedboard,fpin);
                fclose(fpin);
                break;
        case 4:fpin=fopen("Easy4.txt","r");
                if(fpin==NULL){return -1;}
                Copyboard(board,fpin,helpboard);
                fclose(fpin);
                fpin=fopen("Easy4solved.txt","r");
                if(fpin==NULL){return -1;}
                Copysolvedboard(solvedboard,fpin);
                fclose(fpin);
                break;}

        break;}
        else{continue;}
        }

    break;}
    if(130<= m && m<=230 && 288<=n && n<=312){
        Hardness1[1].reset(180,150,"Please select one of the following");


        for(;;){
            int v=getClick();
            int z=Levelcheck(v);
        if(0<z&&z<5){
            Hardness1[1].hide();
            for(int k=0;k<4;k++){
        Hardness[k].hide();
        Level[k].hide();
        }
        switch(z){
        case 1:fpin=fopen("Medium1.txt","r");
                if(fpin==NULL){return -1;}
                Copyboard(board,fpin,helpboard);
                fclose(fpin);
                fpin=fopen("Medium1solved.txt","r");
                if(fpin==NULL){return -1;}
                Copysolvedboard(solvedboard,fpin);
                fclose(fpin);
                break;
        case 2:fpin=fopen("Medium2.txt","r");
                if(fpin==NULL){return -1;}
                Copyboard(board,fpin,helpboard);
                fclose(fpin);
                fpin=fopen("Medium2solved.txt","r");
                if(fpin==NULL){return -1;}
                Copysolvedboard(solvedboard,fpin);
                fclose(fpin);
                break;
        case 3:fpin=fopen("Medium3.txt","r");
                if(fpin==NULL){return -1;}
                Copyboard(board,fpin,helpboard);
                fclose(fpin);
                fpin=fopen("Medium3solved.txt","r");
                if(fpin==NULL){return -1;}
                Copysolvedboard(solvedboard,fpin);
                fclose(fpin);
                break;
        case 4:fpin=fopen("Medium4.txt","r");
                if(fpin==NULL){return -1;}
                Copyboard(board,fpin,helpboard);
                fclose(fpin);
                fpin=fopen("Medium4solved.txt","r");
                if(fpin==NULL){return -1;}
                Copysolvedboard(solvedboard,fpin);
                fclose(fpin);
                break;}

        break;}
        else{continue;}
        }


    break;}
    if(130<= m && m<=230 && 338<=n && n<=362){
        Hardness1[2].reset(180,150,"Please select one of the following");

        for(;;){
            int v=getClick();
            int z=Levelcheck(v);
        if(0<z&&z<5){
            Hardness1[2].hide();
            for(int k=0;k<4;k++){
        Hardness[k].hide();
        Level[k].hide();
        }
        switch(z){
        case 1:fpin=fopen("Hard1.txt","r");
                if(fpin==NULL){return -1;}
                Copyboard(board,fpin,helpboard);
                fclose(fpin);
                fpin=fopen("Hard1solved.txt","r");
                if(fpin==NULL){return -1;}
                Copysolvedboard(solvedboard,fpin);
                fclose(fpin);
                break;
        case 2:fpin=fopen("Hard2.txt","r");
                if(fpin==NULL){return -1;}
                Copyboard(board,fpin,helpboard);
                fclose(fpin);
                fpin=fopen("Hard2solved.txt","r");
                if(fpin==NULL){return -1;}
                Copysolvedboard(solvedboard,fpin);
                fclose(fpin);
                break;
        case 3:fpin=fopen("Hard3.txt","r");
                if(fpin==NULL){return -1;}
                Copyboard(board,fpin,helpboard);
                fclose(fpin);
                fpin=fopen("Hard3solved.txt","r");
                if(fpin==NULL){return -1;}
                Copysolvedboard(solvedboard,fpin);
                fclose(fpin);
                break;
        case 4:fpin=fopen("Hard4.txt","r");
                if(fpin==NULL){return -1;}
                Copyboard(board,fpin,helpboard);
                fclose(fpin);
                fpin=fopen("Hard4solved.txt","r");
                if(fpin==NULL){return -1;}
                Copysolvedboard(solvedboard,fpin);
                fclose(fpin);
                break;}

        break;}
        else{continue;}
        }
    break;}






    else{continue;}


}


slots s[9][9];
slots Numbers[10];



for(int i=0;i<9;i++){
        for(int j=0;j<9;j++){

            s[i][j].r.reset(i*40+20,j*40+20,40,40);
            s[i][j].r.setColor(COLOR(83,104,120));
            s[i][j].t=s[i][j].t=new Text(i*40+20,j*40+20,board[i][j]);
            if(s[i][j].t!=NULL){

            }
            s[i][j].t->hide();
        }
}



Line l[8];
    for(int i=0;i<4;i++){
        l[i].reset(i*120,0,i*120,360);
        l[i+4].reset(0,i*120,360,i*120);
        l[i].setColor(YELLOW);
        l[i+4].setColor(YELLOW);
    }

    Rectangle Ver(180,400,100,24);

    Text Veri(180,400,"VERIFY");

    Rectangle Hint(180,440,100,24);

    Text Hints(180,440,"Hint");

    Text Note1(180,500,"If You Want To Verify First click verify and ");

    Text Note2(180,520,"then select the box.If you want enter an ");

    Text Note3(180,540,"input directly By Selecting the box you can enter.");

    Text Note4(180,560,"If You Want delete a Particular Number you entered");

    Text Note5(180,580,"Press 0,If you want Soluttion Press ANSWER below");

    Rectangle Answ(180,610,100,24);

    Text Answer(180,610,"ANSWER");

    for(int n=0;n<10;n++){
    Numbers[n].r.reset(380,n*40+20,20,20);
    Numbers[n].t=new Text(380,n*40+20,n);
    }


    for(int i=0;i<9;i++){
    for(int j=0;j<9;j++){

    if(board[i][j]!=0){
    s[i][j].r.setColor(COLOR(83,104,120));
    s[i][j].r.setFill(COLOR(83,104,120));
    s[i][j].t->reset(i*40+20,j*40+20,board[i][j]);
    s[i][j].t->setColor(COLOR(83,104,120));
    s[i][j].t->setFill(COLOR(83,104,120));
    };
    }
}

for(;;){
        int v=getClick();
        int x=(v/65536)/40;
        int y=(v%65536)/40;

        if(x>8||y>8){
            int m=(v/65536);
            int n=(v%65536);
            if(130<= m && m<=230 && 598<=n && n <=622){
                Copysolution(board,solvedboard);
                for(int i1=0;i1<9;i1++){
                    for(int j1=0;j1<9;j1++){
                        s[i1][j1].t->reset(i1*40+20,j1*40+20,board[i1][j1]);



                    }
                    }
                    break;

            }
            if(130<= m && m<=230 && 428<=n && n <=452){
                Hint.setColor(COLOR(83,104,120));
                Hint.setFill(COLOR(83,104,120));
                int v=getClick();
                int a=(v/65536)/40;
                int b=v%65536/40;
                if(a>8||b>8){Hint.setColor(WHITE);
                        Hint.setFill(BLACK);
                        Hint.setColor(BLACK);
                    continue;}
                else{if(helpboard[a][b]!=1){
                    board[a][b]=solvedboard[a][b];
                    helpboard[a][b]=1;
                    s[a][b].r.setFill(COLOR(83,104,120));
                    s[a][b].t->reset(a*40+20,b*40+20,board[a][b]);
                    Hint.setColor(WHITE);
                        Hint.setFill(BLACK);
                        Hint.setColor(BLACK);
                    continue;
                    }
                else{Hint.setColor(WHITE);
                        Hint.setFill(BLACK);
                        Hint.setColor(BLACK);
                        continue;}
                }


            }
            if(130<= m && m<=230 && 388<=n && n <=412){
                Ver.setColor(COLOR(83,104,120));
                Ver.setFill(COLOR(83,104,120));
                int v1=getClick();
                int i=(v1/65536)/40;
                int j=(v1%65536)/40;
                if(i>8||j>8){
                    Ver.setColor(WHITE);
                        Ver.setFill(BLACK);
                        Ver.setColor(BLACK);
                    continue;
                }
                else{

                    if(helpboard[i][j]!=1&&board[i][j]!=0){
                        if(CheckingValidity(board,i,j)){
                        s[i][j].r.setColor(GREEN);
                        s[i][j].r.setFill(GREEN);
                        wait(1);
                        s[i][j].r.setColor(WHITE);
                        s[i][j].r.setFill(BLACK);
                        s[i][j].r.setColor(COLOR(83,104,120));
                        Ver.setColor(WHITE);
                        Ver.setFill(BLACK);
                        Ver.setColor(BLACK);
                        continue;
                    }
                    else{
                        s[i][j].r.setColor(RED);
                        s[i][j].r.setFill(RED);
                        wait(1);
                        s[i][j].r.setColor(WHITE);
                        s[i][j].r.setFill(BLACK);
                        s[i][j].r.setColor(COLOR(83,104,120));
                        Ver.setColor(WHITE);
                        Ver.setFill(BLACK);
                        Ver.setColor(BLACK);

                        continue;
                    }
              }
              else{Ver.setColor(WHITE);
                        Ver.setFill(BLACK);
                        Ver.setColor(BLACK);
                        continue;}
              }


            }
            else{continue;}
        }
    else{
        if(helpboard[x][y]!=1){
        s[x][y].r.setColor(YELLOW);
        s[x][y].r.setFill(YELLOW);
        int v4=getClick();
        int m=v4/65536;
        int n=v4%65536;
        int h=GetValue(m,n);
        if(h!=10){board[x][y]=h;}
        else{s[x][y].r.setColor(WHITE);
        s[x][y].r.setFill(BLACK);
        s[x][y].r.setColor(COLOR(83,104,120));
        continue;}


        if(board[x][y]!=0){s[x][y].t->reset(x*40+20,y*40+20,board[x][y]);
        s[x][y].r.setColor(WHITE);
        s[x][y].r.setFill(BLACK);
        s[x][y].r.setColor(COLOR(83,104,120));

        }
   else{
        s[x][y].t->hide();
        s[x][y].r.setColor(WHITE);
        s[x][y].r.setFill(BLACK);
        s[x][y].r.setColor(COLOR(83,104,120));}
    }
    else{continue;}
        }


        }

wait(60);
}
